namespace HexaGrid
{
  public class EffectPluginConfigToken : PaintDotNet.Effects.EffectConfigToken
  {
    // Here are all of my variables
    public int SizeHexa;
    public int SizeHexb;
    public bool SizeLink;
    public int BrushWidth;
    public int TransAlpha;
    public bool AntiAliased;
    public bool SpotCross;
    public bool DrawMode1;
    public bool DrawMode2;
    public bool DrawMode3;
    public bool DrawMode4;
    public bool DrawMode5;
    public bool DrawMode6;
    public bool EndMode;
    public System.Drawing.Color Color1;
    public System.Drawing.Color Color2;
    public System.Drawing.Color ColorSpot;

    public EffectPluginConfigToken()
      : base()
    {
      // Here are the variable defaults
      SizeHexa = 100;
      SizeHexb = 100;
      SizeLink = true;
      TransAlpha = 255;
      BrushWidth = 2;
      AntiAliased = true;
      SpotCross = false;
      DrawMode1 = true;
      DrawMode2 = false;
      DrawMode3 = false;
      DrawMode4 = false;
      DrawMode5 = false;
      DrawMode6 = false;
      EndMode = false;
      Color1 = System.Drawing.Color.Black;
      Color2 = System.Drawing.Color.Black;
      ColorSpot = System.Drawing.Color.Gray;
    }

    protected EffectPluginConfigToken(EffectPluginConfigToken copyMe)
      : base(copyMe)
    {
      SizeHexa = copyMe.SizeHexa;
      SizeHexb = copyMe.SizeHexb;
      SizeLink = copyMe.SizeLink;
      TransAlpha = copyMe.TransAlpha;
      BrushWidth = copyMe.BrushWidth;
      AntiAliased = copyMe.AntiAliased;
      SpotCross = copyMe.SpotCross;
      DrawMode1 = copyMe.DrawMode1;
      DrawMode2 = copyMe.DrawMode2;
      DrawMode3 = copyMe.DrawMode3;
      DrawMode4 = copyMe.DrawMode4;
      DrawMode5 = copyMe.DrawMode5;
      DrawMode6 = copyMe.DrawMode6;
      EndMode = copyMe.EndMode;
      Color1 = copyMe.Color1;
      Color2 = copyMe.Color2;
      ColorSpot = copyMe.ColorSpot;
    }

    public override object Clone()
    {
      return new EffectPluginConfigToken(this);
    }
  }
}